Lattice Grid Buy a licence

demo D107

Cell comments

Threaded discussion on a cell, with an unresolved count

grid.comments

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

// Your comment store, which the grid does not own. Each method is async because
// a real one is a fetch: wire these to your own back end. The grid passes a
// cell key (row key joined with the field) to identify the thread.
const comments = {
  provider: {
    async loadIndex(rowIds: string[], fields: string[]) {
      // Return a descriptor per commented cell in the requested rows:
      // { rowId, field, count, unresolved, updated }.
      return [];
    },
    async loadThread(cellKey: string) {
      // Return the comments on this cell, oldest first.
      return [];
    },
    async addComment(cellKey: string, body: string, parentId: string, context: any) {
      // Persist and return the new comment.
    },
    async editComment(commentId: string, body: string) {
      // Persist and return the edited comment.
    },
    async deleteComment(commentId: string) {
      // Remove the comment.
    },
    async resolveThread(cellKey: string) {
      // Mark the thread resolved.
    },
    async unresolveThread(cellKey: string) {
      // Reopen the thread.
    },
  },
  // Emphasis, code and links only, built as elements rather than parsed as markup.
  markdown: true,
  rowLabel: (row: any) => row?.data?.circuit ?? 'this row',
};

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    // Required, not advisory. Comments outlive the values they annotate, so the
    // grid needs a stable key to reattach each thread across sorts.
    rowKey: 'id',
    selection: 'multiple',
    comments,
    columns: [
      { field: 'circuit', title: 'Circuit', layout: { width: 200, pin: 'start' } },
      { field: 'region', title: 'Region' },
      { field: 'status', title: 'Status', filter: { type: 'set' } },
      { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' } },
      { field: 'charge', title: 'Monthly charge', type: 'number',
        format: { style: 'currency', currency: 'GBP' }, filter: { type: 'number' } },
    ],
    rows: [/* an array of objects, one per circuit */],
  };
}

bootstrapApplication(AppComponent);

Threaded comments anchored to a cell, with an unresolved count

Cell comments attach a threaded discussion to a single cell rather than to a row or the grid as a whole, so a question about one value stays with that value as the sheet is sorted, filtered or scrolled. Reach for this in any JavaScript data grid that supports review workflows: a finance team querying a variance, an editor flagging a figure for a source, or a reviewer leaving a note for the next person to look at the sheet. Lattice Grid exposes the feature through grid.comments, which reads and writes threads keyed by cell address, so a host application can seed existing discussion on load, append a reply, or mark a thread resolved without the grid dictating how comments are stored or synced elsewhere.

Each commented cell carries an unresolved count rather than a single flag, so a cell with three open replies reads differently from one where the last word has been said. The indicator renders from the same virtualised cell layer as ordinary content, so marking thousands of cells across a large sheet costs no more per cell than any other cell state. Comment indicators carry an accessible label announcing the open count, so a screen reader user navigating by cell hears that a value has outstanding discussion without opening the thread.

How do you add comments to a cell in a data grid?

Use grid.comments to attach a thread to a cell address, then add replies or mark the thread resolved through the same interface. Lattice Grid tracks an unresolved count per cell and renders an indicator from the cell layer, so commented cells stay marked correctly through sorting, filtering and scrolling.

Lattice Grid Buy a licence

demo D107

Cell comments

Threaded discussion on a cell, with an unresolved count

grid.comments

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { width: 200, pin: 'start' } },
    { field: 'region', title: 'Region' },
    { field: 'status', title: 'Status', filter: { type: 'set' } },
    { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' } },
    { field: 'charge', title: 'Monthly charge', type: 'number',
      format: { style: 'currency', currency: 'GBP' }, filter: { type: 'number' } },
  ];

  // Your comment store, which the grid does not own. Each method is async
  // because a real one is a fetch: wire these to your own back end. The grid
  // passes a cell key (row key joined with the field) to identify the thread.
  const comments = {
    provider: {
      async loadIndex(rowIds, fields) {
        // Return a descriptor per commented cell in the requested rows:
        // { rowId, field, count, unresolved, updated }.
        return [];
      },
      async loadThread(cellKey) {
        // Return the comments on this cell, oldest first.
        return [];
      },
      async addComment(cellKey, body, parentId, context) {
        // Persist and return the new comment.
      },
      async editComment(commentId, body) {
        // Persist and return the edited comment.
      },
      async deleteComment(commentId) {
        // Remove the comment.
      },
      async resolveThread(cellKey) {
        // Mark the thread resolved.
      },
      async unresolveThread(cellKey) {
        // Reopen the thread.
      },
    },
    // Emphasis, code and links only, built as elements rather than parsed as markup.
    markdown: true,
    rowLabel: (row) => row?.data?.circuit ?? 'this row',
  };

  const rows = [/* an array of objects, one per circuit */];

  function App() {
    return (
      <LatticeGrid
        // Required, not advisory. Comments outlive the values they annotate, so
        // the grid needs a stable key to reattach each thread across sorts.
        rowKey="id"
        selection="multiple"
        comments={comments}
        columns={columns}
        rows={rows}
        style={{ height: '540px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Threaded comments anchored to a cell, with an unresolved count

Cell comments attach a threaded discussion to a single cell rather than to a row or the grid as a whole, so a question about one value stays with that value as the sheet is sorted, filtered or scrolled. Reach for this in any JavaScript data grid that supports review workflows: a finance team querying a variance, an editor flagging a figure for a source, or a reviewer leaving a note for the next person to look at the sheet. Lattice Grid exposes the feature through grid.comments, which reads and writes threads keyed by cell address, so a host application can seed existing discussion on load, append a reply, or mark a thread resolved without the grid dictating how comments are stored or synced elsewhere.

Each commented cell carries an unresolved count rather than a single flag, so a cell with three open replies reads differently from one where the last word has been said. The indicator renders from the same virtualised cell layer as ordinary content, so marking thousands of cells across a large sheet costs no more per cell than any other cell state. Comment indicators carry an accessible label announcing the open count, so a screen reader user navigating by cell hears that a value has outstanding discussion without opening the thread.

How do you add comments to a cell in a data grid?

Use grid.comments to attach a thread to a cell address, then add replies or mark the thread resolved through the same interface. Lattice Grid tracks an unresolved count per cell and renders an indicator from the cell layer, so commented cells stay marked correctly through sorting, filtering and scrolling.